unit MyListUnit;

interface

uses
  System.SysUtils, System.Generics.Collections;

type
  TMyData = record
  public
    Value1 : Integer;
    Value2 : String;

  public
    constructor Create( AValue1 : Integer; AValue2 : String );

  end;
//---------------------------------------------------------------------------
  TMyList1<T> = class( TList<T> )
  protected
    type
      TMyProc = procedure( AItem : T ) of object;

  public
    procedure ForEach( AProc : TMyProc );

  end;
//---------------------------------------------------------------------------
  TMyList2<T> = class( TList<T> )
  protected
    type
      TMyProc = reference to procedure( AItem : T );

  public
    procedure ForEach( AProc : TMyProc );

  end;
//---------------------------------------------------------------------------
  TMyList3<T> = class( TList<T> )
  public
    procedure ForEach( AProc : TProc<T> );
    procedure ForEachWhere( AProc : TProc<T>; AFunc : TFunc<T,Boolean> );

  end;
//---------------------------------------------------------------------------
  TMemberProc<T> = procedure( AItem : T ) of object;
//---------------------------------------------------------------------------
  TDelegate<TItem : class> = class
  public
    class function Execute<T1>( AMethod : Pointer; const AItem1 : T1 ) : TProc<TItem>; overload;

  end;
//---------------------------------------------------------------------------
procedure PopulateTestList( const AList : TList<TMyData> );
//---------------------------------------------------------------------------
implementation

//---------------------------------------------------------------------------
constructor TMyData.Create( AValue1 : Integer; AValue2 : String );
begin
  Value1 := AValue1;
  Value2 := AValue2;
end;
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
procedure TMyList1<T>.ForEach( AProc : TMyProc );
var
  AValue : T;

begin
  for AValue in Self do
    AProc( AValue );

end;
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
procedure TMyList2<T>.ForEach( AProc : TMyProc );
var
  AValue : T;

begin
  for AValue in Self do
    AProc( AValue );

end;
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
procedure TMyList3<T>.ForEach( AProc : TProc<T> );
var
  AValue : T;

begin
  for AValue in Self do
    AProc( AValue );

end;
//---------------------------------------------------------------------------
procedure TMyList3<T>.ForEachWhere( AProc : TProc<T>; AFunc : TFunc<T,Boolean> );
var
  AValue : T;

begin
  for AValue in Self do
    if( AFunc( AValue ) ) then
      AProc( AValue );

end;
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
class function TDelegate<TItem>.Execute<T1>( AMethod : Pointer; const AItem1 : T1 ) : TProc<TItem>;
begin
  Result := procedure( AItem : TItem )
            var
              AExecMethod : TMethod;

            begin
              AExecMethod.Code := AMethod;
              AExecMethod.Data := Pointer( AItem );
              TMemberProc<T1>( AExecMethod )( AItem1 );
            end;

end;
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
procedure PopulateTestList( const AList : TList<TMyData> );
begin
  AList.Add( TMyData.Create( 3,  'Hello' ));
  AList.Add( TMyData.Create( 7,  'Hi' ));
  AList.Add( TMyData.Create( 33, 'Bye' ));
  AList.Add( TMyData.Create( 12, 'Again' ));
  AList.Add( TMyData.Create( 1,  'World' ));
  AList.Add( TMyData.Create( 7,  'Hi again' ));
end;
//---------------------------------------------------------------------------
end.
