unit SmartPointerUnit;

interface

uses
  System.Classes, System.SysUtils;

type
  ISmartPointer<T : class> = interface( TFunc<T> )
  end;
//---------------------------------------------------------------------------
  TSmartPointer<T : class> = class( TInterfacedObject, ISmartPointer<T> )
  private
    FValue : T;

  public
    constructor Create( AValue : T );
    destructor  Destroy(); override;

  public
    function  Invoke() : T;

  end;
//---------------------------------------------------------------------------
implementation

//---------------------------------------------------------------------------
constructor TSmartPointer<T>.Create( AValue : T );
begin
  FValue := AValue;
end;
//---------------------------------------------------------------------------
destructor TSmartPointer<T>.Destroy();
begin
  FValue.Free();
end;
//---------------------------------------------------------------------------
function TSmartPointer<T>.Invoke() : T;
begin
  Result := FValue;
end;
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
end.
