unit Unit10;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls;

type
  TMyThread = class;

  TForm9 = class(TForm)
    Label1: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    { Private declarations }
    FThread : TMyThread;

  public
    { Public declarations }
  end;

  TMyThread = class( TThread )
  protected
    FForm : TForm9;

  public
    procedure Execute(); override;

  public
    constructor Create( AForm : TForm9 );

  end;

var
  Form9: TForm9;

implementation

{$R *.dfm}

constructor TMyThread.Create( AForm : TForm9 );
begin
  inherited Create();
  FForm := AForm;
end;

procedure TMyThread.Execute();
var
  ACounter : Integer;

begin
  ACounter := 0;
  while( not Terminated ) do
    begin
    Synchronize(
        procedure()
        begin
          FForm.Label1.Caption := IntToStr( ACounter );
        end
      );

    Inc( ACounter );
    Sleep( 1000 );
    end;

end;

procedure TForm9.FormCreate(Sender: TObject);
begin
  FThread := TMyThread.Create( Self );
end;

procedure TForm9.FormDestroy(Sender: TObject);
begin
  FThread.Free();
end;

end.
