unit Unit13;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, MyThreadingUnit;

type
  TForm13 = class(TForm)
    Memo1: TMemo;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form13: TForm13;

implementation

{$R *.dfm}

procedure TForm13.Button1Click(Sender: TObject);
var
  AList   : array of Integer;
  AIndex  : Integer;

  AExecution : TMyExecution;

begin
  Memo1.Lines.Clear();
  SetLength( AList, 10 );

  AExecution := TMyExecution.Create();

  for AIndex := 0 to Length( AList ) do
    AExecution.ExecuteProc(
        procedure()
        begin
          AList[ AIndex ] := AIndex * 2;
          Sleep( 1000 );
        end
      );

  AExecution.WaitFor();
  for AIndex := 0 to Length( AList ) do
    Memo1.Lines.Add( IntToStr( AList[ AIndex ] ));

end;

procedure TForm13.Button2Click(Sender: TObject);
var
  AList   : array of Integer;
  AIndex  : Integer;

  AExecution : TMyExecution;

  procedure ExecuteOne( ALocalIndex : Integer );
  begin
    AExecution.ExecuteProc(
          procedure()
          begin
            AList[ ALocalIndex ] := ALocalIndex * 2;
            Sleep( 1000 );
          end
        );

  end;

begin
  Memo1.Lines.Clear();
  SetLength( AList, 10 );

  AExecution := TMyExecution.Create();

  for AIndex := 0 to Length( AList ) do
    ExecuteOne( AIndex );

  AExecution.WaitFor();
  for AIndex := 0 to Length( AList ) do
    Memo1.Lines.Add( IntToStr( AList[ AIndex ] ));

end;

procedure TForm13.Button3Click(Sender: TObject);
var
  AList   : array of Integer;
  AIndex  : Integer;

  AExecution : TMyExecution;

begin
  Memo1.Lines.Clear();
  SetLength( AList, 10 );

  AExecution := TMyExecution.Create();

  for AIndex := 0 to Length( AList ) do
    AExecution.ExecuteProc(
      TDelegate.Capture<Integer>( AIndex,
          procedure( ALocalIndex : Integer )
          begin
            AList[ ALocalIndex ] := ALocalIndex * 2;
            Sleep( 1000 );
          end
        ));

  AExecution.WaitFor();
  for AIndex := 0 to Length( AList ) do
    Memo1.Lines.Add( IntToStr( AList[ AIndex ] ));

end;

end.
