unit Unit5;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, System.Generics.Collections, MyListUnit;

type
  TForm5 = class(TForm)
    Button1: TButton;
    Memo1: TMemo;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    { Private declarations }
    FList   : TMyList1<TMyData>;

  public
    { Public declarations }
  end;

var
  Form5: TForm5;

implementation

{$R *.dfm}

type
  THelperClass = class
  protected
    FValue  : Integer;
    FForm   : TForm5;

  public
    constructor Create( AForm : TForm5; AValue : Integer );

  public
    procedure PrintItem( AItem : TMyData );

  end;

procedure TForm5.Button1Click(Sender: TObject);
var
  AHelper : THelperClass;

begin
  Memo1.Lines.Clear();

  AHelper := THelperClass.Create( Self, 7 );
  try
    FList.ForEach( AHelper.PrintItem );
  finally
    AHelper.Free();
    end;

end;

procedure TForm5.FormCreate(Sender: TObject);
begin
  FList := TMyList1<TMyData>.Create();
  PopulateTestList( FList );
end;

procedure TForm5.FormDestroy(Sender: TObject);
begin
  FList.Free();
end;

constructor THelperClass.Create( AForm : TForm5; AValue : Integer );
begin
  inherited Create();
  FForm := AForm;
  FValue := AValue;
end;

procedure THelperClass.PrintItem( AItem : TMyData );
begin
  if( AItem.Value1 = FValue ) then
    FForm.Memo1.Lines.Add( AItem.Value2 );

end;

end.
