unit Unit6;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, System.Generics.Collections, MyListUnit;

type
  TForm6 = class(TForm)
    Button1: TButton;
    Memo1: TMemo;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
    FList   : TMyList1<TMyData>;

  public
    { Public declarations }
  end;

var
  Form6: TForm6;

implementation

{$R *.dfm}

type
  THelperClass = class;

  IHelperClass = interface
    ['{FDA4D6B2-FF40-4A21-B1DE-6E3D949B9F81}']

    function GetInstance() : THelperClass;

  end;

  THelperClass = class( TInterfacedObject, IHelperClass )
  protected
    FValue  : Integer;
    FForm   : TForm6;

  public
    constructor Create( AForm : TForm6; AValue : Integer );

  public
    function  GetInstance() : THelperClass;
    procedure PrintItem( AItem : TMyData );

  end;

procedure TForm6.Button1Click(Sender: TObject);
var
  AHelper : IHelperClass;

begin
  Memo1.Lines.Clear();

  AHelper := THelperClass.Create( Self, 7 );
  FList.ForEach( AHelper.GetInstance().PrintItem );
end;

procedure TForm6.FormCreate(Sender: TObject);
begin
  FList := TMyList1<TMyData>.Create();
  PopulateTestList( FList );
end;

procedure TForm6.FormDestroy(Sender: TObject);
begin
  FList.Free();
end;

constructor THelperClass.Create( AForm : TForm6; AValue : Integer );
begin
  inherited Create();
  FForm := AForm;
  FValue := AValue;
end;

function THelperClass.GetInstance() : THelperClass;
begin
  Result := Self;
end;

procedure THelperClass.PrintItem( AItem : TMyData );
begin
  if( AItem.Value1 = FValue ) then
    FForm.Memo1.Lines.Add( AItem.Value2 );

end;

end.

