unit Unit8;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, System.Generics.Collections, MyListUnit;

type
  TForm8 = class(TForm)
    Button1: TButton;
    Memo1: TMemo;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Memo2: TMemo;
    Button5: TButton;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
  private
    { Private declarations }
    FList   : TMyList3<TMyData>;

  private
    procedure PrintItems( AMemo : TMemo; AValue : Integer );

    function  GetPrintItems( AMemo : TMemo; AValue : Integer; APrintAll : Boolean ) : TProc<TMyData>;

  public
    { Public declarations }
  end;

var
  Form8: TForm8;

implementation

{$R *.dfm}

procedure TForm8.Button1Click(Sender: TObject);
begin
  Memo1.Lines.Clear();

  FList.ForEach(
      procedure( AItem : TMyData )
      begin
        Memo1.Lines.Add( AItem.Value2 );
      end
    );

end;

procedure TForm8.Button2Click(Sender: TObject);
begin
  Memo1.Lines.Clear();

  FList.ForEachWhere(
      procedure( AItem : TMyData )
      begin
        Memo1.Lines.Add( AItem.Value2 );
      end
    ,
      function( AItem : TMyData ) : Boolean
      begin
        Result := ( AItem.Value1 = 7 );
      end
    );

end;

procedure TForm8.Button3Click(Sender: TObject);
begin
  PrintItems( Memo1, 7 );
end;

procedure TForm8.Button4Click(Sender: TObject);
begin
  PrintItems( Memo2, 3 );
end;

procedure TForm8.Button5Click(Sender: TObject);
begin
  Memo1.Lines.Clear();
  FList.ForEach( GetPrintItems( Memo1, 7, False ));

  Memo2.Lines.Clear();
  FList.ForEach( GetPrintItems( Memo2, 0, True ));
end;

procedure TForm8.FormCreate(Sender: TObject);
begin
  FList := TMyList3<TMyData>.Create();
  PopulateTestList( FList );
end;

procedure TForm8.FormDestroy(Sender: TObject);
begin
  FList.Free();
end;

procedure TForm8.PrintItems( AMemo : TMemo; AValue : Integer );
begin
  AMemo.Lines.Clear();

  FList.ForEach(
      procedure( AItem : TMyData )
      begin
        if( AItem.Value1 = AValue ) then
          AMemo.Lines.Add( AItem.Value2 );

      end
    );

end;

function TForm8.GetPrintItems( AMemo : TMemo; AValue : Integer; APrintAll : Boolean ) : TProc<TMyData>;
begin
  if( APrintAll ) then
    Result := procedure( AItem : TMyData )
      begin
        AMemo.Lines.Add( AItem.Value2 );
      end

  else
    Result := procedure( AItem : TMyData )
      begin
        if( AItem.Value1 = AValue ) then
          AMemo.Lines.Add( AItem.Value2 );

      end;

end;

end.
