unit Unit9;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls;

type
  TForm9 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    CheckBox1: TCheckBox;
    Edit1: TEdit;
    Button3: TButton;
    Button4: TButton;
    CheckBox2: TCheckBox;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form9: TForm9;

implementation

{$R *.dfm}

uses
  AnotherFormUnit, MyListUnit;

type
  TWinControlHelper = class helper for TWinControl
  public
    procedure ForEachControl( APtoc : TProc<TControl> );
    procedure ForEachControlOfType( AClass : TControlClass; APtoc : TProc<TControl> );

  end;

procedure TWinControlHelper.ForEachControl( APtoc : TProc<TControl> );
var
  I : Integer;

begin
  for I := 0 to ControlCount - 1 do
    APtoc( Controls[ I ] );

end;

procedure TWinControlHelper.ForEachControlOfType( AClass : TControlClass; APtoc : TProc<TControl> );
var
  I : Integer;

begin
  for I := 0 to ControlCount - 1 do
    if( Controls[ I ] is AClass ) then
      APtoc( Controls[ I ] );

end;

procedure TForm9.Button1Click(Sender: TObject);
begin
  ForEachControl(
      procedure( AItem : TControl )
      begin
        AItem.Enabled := False;
      end
    );

end;

procedure TForm9.Button2Click(Sender: TObject);
begin
  ForEachControlOfType(
      TCheckBox
    ,
      procedure( AItem : TControl )
      begin
        AItem.Enabled := False;
      end
    );

end;

procedure TForm9.Button3Click(Sender: TObject);
var
  AForm: TForm;

begin
  AForm := TAnotherForm.Create( Self );
  AForm.ForEachControlOfType(
      TButton
    ,
      procedure( AItem : TControl )
      begin
        AItem.Enabled := False;
      end
    );

  AForm.Show();
end;

procedure TForm9.Button4Click(Sender: TObject);
begin
  ForEachControlOfType( TButton, TDelegate<TControl>.Execute<String>( @TButton.SetTextBuf, 'Hello' ));
end;

end.
